#include <amxmodx>
#include <engine>
#include <fakemeta>
#include <fakemeta_util>
#include <fun>
#include <hamsandwich>
#include <xs>
#include <cstrike>

enum
{
	anim_idle,
	anim_reload,
	anim_draw,
	anim_shoot1,
	anim_shoot2,
	anim_shoot3
}
new g_mode[33]
new g_anim[33]
new g_ammo[33]
new g_mode2[33]
new g_oldammo[33]
#define ENG_NULLENT		-1
#define EV_INT_WEAPONKEY	EV_INT_impulse
#define svdex_WEAPONKEY	903
#define MAX_PLAYERS  			  32
#define IsValidUser(%1) (1 <= %1 <= g_MaxPlayers)
new sExplo, sSmoke
const USE_STOPPED = 0
const OFFSET_ACTIVE_ITEM = 373
const OFFSET_WEAPONOWNER = 41
const OFFSET_LINUX = 5
const OFFSET_LINUX_WEAPONS = 4
new const GRENADE_MODEL[] = "models/grenade.mdl"
#define WEAP_LINUX_XTRA_OFF			4
#define m_fKnown				44
#define m_flNextPrimaryAttack 			46
#define m_flTimeWeaponIdle			48
#define m_iClip					51
#define m_fInReload				54
#define PLAYER_LINUX_XTRA_OFF			5
#define m_flNextAttack				83

new sTrail
#define svdex_RELOAD_TIME 3.5
new const GRENADE_EXPLOSION[] = "sprites/zerogxplode.spr"
new const GRENADE_SMOKE[] = "sprites/black_smoke3.spr"
const PRIMARY_WEAPONS_BIT_SUM = (1<<CSW_SCOUT)|(1<<CSW_XM1014)|(1<<CSW_MAC10)|(1<<CSW_AUG)|(1<<CSW_UMP45)|(1<<CSW_SG550)|(1<<CSW_GALIL)|(1<<CSW_FAMAS)|(1<<CSW_AWP)|(1<<CSW_MP5NAVY)|(1<<CSW_M249)|(1<<CSW_M3)|(1<<CSW_M4A1)|(1<<CSW_TMP)|(1<<CSW_G3SG1)|(1<<CSW_SG552)|(1<<CSW_AK47)|(1<<CSW_P90)
new const WEAPONENTNAMES[][] = { "", "weapon_p228", "", "weapon_scout", "weapon_hegrenade", "weapon_xm1014", "weapon_c4", "weapon_mac10",
			"weapon_aug", "weapon_smokegrenade", "weapon_elite", "weapon_fiveseven", "weapon_ump45", "weapon_m4a1",
			"weapon_galil", "weapon_famas", "weapon_usp", "weapon_glock18", "weapon_awp", "weapon_mp5navy", "weapon_m249",
			"weapon_m3", "weapon_sg550", "weapon_tmp", "weapon_g3sg1", "weapon_flashbang", "weapon_deagle", "weapon_sg552",
			"weapon_ak47", "weapon_knife", "weapon_p90" }
new const Fire_Sounds[][] = { "weapons/svdex-1.wav","weapons/svdex-launcher.wav" }
new const Sound_Zoom[] = { "weapons/zoom.wav" }
new const GUNSHOT_DECALS[] = { 41, 42, 43, 44, 45 }
new svdex_V_MODEL[64] = "models/v_svdex.mdl"
new svdex_V_MODEL2[64] = "models/v_svdex_2.mdl"
new svdex_P_MODEL[64] = "models/p_svdex.mdl"
new svdex_W_MODEL[64] = "models/w_svdex.mdl"
new cvar_dmg_svdex, cvar_recoil_svdex, g_itemid_svdex, cvar_clip_svdex, cvar_svdex_ammo
new g_has_svdex[33]
new g_MaxPlayers, g_orig_event_svdex, g_clip_ammo[33]
new Float:cl_pushangle[MAX_PLAYERS + 1][3], m_iBlood[2]
new g_svdex_TmpClip[33]
new const g_GrenadeEntity [ ] = "zp_m79_grenade"
//new g_msgScreenShake
new g_reload[33]
new gmsgScoreInfo,gmsgDeathMsg,gmsgScoreAttrib,cvar_survivor,cvar_knockback,cvar_knockbacksurv,cvar_unlim,cvar_gren,cvar_grendmg,cvar_grenrad
new g_itemid2
new SayText
public plugin_init()
{
	register_plugin("[ZP] Weapon: SVDex", "1.0", "Crock / =)")
	register_message(get_user_msgid("DeathMsg"), "message_DeathMsg")
	register_event("CurWeapon","CurrentWeapon","be","1=1")
	RegisterHam(Ham_Item_AddToPlayer, "weapon_ak47", "fw_svdex_AddToPlayer")
	RegisterHam(Ham_Use, "func_tank", "fw_UseStationary_Post", 1)
	RegisterHam(Ham_Use, "func_tankmortar", "fw_UseStationary_Post", 1)
	RegisterHam(Ham_Use, "func_tankrocket", "fw_UseStationary_Post", 1)
	RegisterHam(Ham_Use, "func_tanklaser", "fw_UseStationary_Post", 1)
	for (new i = 1; i < sizeof WEAPONENTNAMES; i++)
		if (WEAPONENTNAMES[i][0]) RegisterHam(Ham_Item_Deploy, WEAPONENTNAMES[i], "fw_Item_Deploy_Post", 1)
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_ak47", "fw_svdex_PrimaryAttack")
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_ak47", "fw_svdex_PrimaryAttack_Post", 1)
	RegisterHam(Ham_Item_PostFrame, "weapon_ak47", "svdex__ItemPostFrame");
	RegisterHam(Ham_Weapon_Reload, "weapon_ak47", "svdex__Reload");
	RegisterHam(Ham_Weapon_Reload, "weapon_ak47", "svdex__Reload_Post", 1);
	RegisterHam(Ham_TakeDamage, "player", "fw_TakeDamage")
	register_forward(FM_SetModel, "fw_SetModel")
	register_forward(FM_CmdStart, "fw_CmdStart")
	register_forward(FM_UpdateClientData, "fw_UpdateClientData_Post", 1)
	register_forward(FM_PlaybackEvent, "fwPlaybackEvent")
	gmsgScoreAttrib = get_user_msgid("ScoreAttrib")
	//g_msgScreenShake = get_user_msgid("ScreenShake")
	cvar_dmg_svdex = register_cvar("zp_svdex_dmg", "2.5")
	cvar_recoil_svdex = register_cvar("zp_svdex_recoil", "1.5")
	register_event("HLTV", "Event_NewRound", 	"a", 	"1=0", "2=0")
	cvar_clip_svdex = register_cvar("zp_svdex_clip", "20")
	register_touch ( g_GrenadeEntity, "*", "touch_m79nade" )
	cvar_svdex_ammo = register_cvar("zp_svdex_ammo", "120")
	gmsgScoreInfo = get_user_msgid("ScoreInfo");
	gmsgDeathMsg = get_user_msgid("DeathMsg");
	cvar_survivor = register_cvar("zp_svdex_surv","0")
	cvar_knockback = register_cvar("zp_svdex_kb","1500")
	cvar_grendmg = register_cvar("zp_svdex_nade_dmg","400")
	cvar_grenrad = register_cvar("zp_svdex_nade_rad","400")
	cvar_gren = register_cvar("zp_svdex_gren","10")
	cvar_knockbacksurv = register_cvar("zp_svdex_kbs","800")
	cvar_unlim = register_cvar("zp_svdex_unlim_g","0")
	gmsgScoreAttrib = get_user_msgid("ScoreAttrib")
	SayText = get_user_msgid("SayText")


	g_MaxPlayers = get_maxplayers()
}
public Event_NewRound() 
{
for(new i;i<= 32;i++)
{
g_reload[i] = 0
g_has_svdex[i] = 0
g_oldammo[i] = get_pcvar_num(cvar_clip_svdex)
if(is_user_alive(i)) set_pev(i, pev_viewmodel2, "models/v_ak47.mdl")
if(is_user_alive(i)) set_pev(i, pev_weaponmodel2, "models/p_ak47.mdl")
}
}
public plugin_precache()
{
	precache_model(svdex_V_MODEL)
	precache_model(svdex_V_MODEL2)
	precache_model(svdex_P_MODEL)
	precache_model(svdex_W_MODEL)
	precache_model(GRENADE_MODEL)
	precache_sound(Sound_Zoom)
	precache_sound("weapons/svdex_clipin.wav")
	precache_sound("weapons/svdex_clipout.wav")
	precache_sound("weapons/svdex_clipon.wav")
	precache_sound("weapons/svdex_draw.wav")
	precache_sound("weapons/svdex_exp.wav")
	precache_sound("weapons/svdex-launcher.wav")
	precache_sound("weapons/svdex_foley1.wav")
	precache_sound("weapons/svdex_foley2.wav")
	precache_sound("weapons/svdex_foley3.wav")
	precache_sound("weapons/svdex_foley4.wav")
	precache_sound(Fire_Sounds[0])
	sExplo = precache_model(GRENADE_EXPLOSION)
	sSmoke = precache_model(GRENADE_SMOKE)
	precache_sound(Fire_Sounds[1])
	m_iBlood[0] = precache_model("sprites/blood.spr")
	m_iBlood[1] = precache_model("sprites/bloodspray.spr")
	precache_model("sprites/640hud5.spr")
	register_forward(FM_PrecacheEvent, "fwPrecacheEvent_Post", 1)
}
public plugin_natives ()
{
	register_native("give_weapon_svdex", "native_give_weapon_add", 1)
}
public native_give_weapon_add(id)
{
give_svdex(id)
}

public zp_user_humanized_post(id)
{
if(zp_get_user_survivor(id) && get_pcvar_num(cvar_survivor) == 1) give_svdex(id)
}
public fwPrecacheEvent_Post(type, const name[])
{
	if (equal("events/ak47.sc", name))
	{
		g_orig_event_svdex = get_orig_retval()
		return FMRES_HANDLED
	}
	
	return FMRES_IGNORED
}
public fw_CmdStart(id, uc_handle, seed)
{
	if(id > 0 && id < 33)
	{
	if(!is_user_alive(id) || zp_get_user_zombie(id)) 
	return PLUGIN_HANDLED

	if((get_uc(uc_handle, UC_Buttons) & IN_ATTACK2) && !(pev(id, pev_oldbuttons) & IN_ATTACK2) && g_mode2[id] == 0 && g_reload[id] == 0)
	{
		new szClip, szAmmo
		new szWeapID = get_user_weapon(id, szClip, szAmmo)
		if(szWeapID == CSW_AK47 && g_has_svdex[id])
		{
		if(g_mode[id]==0)
		{
		if(g_ammo[id] > 0)
		{
		set_task(1.5,"mode_new",id)
		g_mode2[id] = 1
		UTIL_PlayWeaponAnimation(id, 6)
		g_oldammo[id] = szClip
		//client_print(id,print_chat,"a: %d",g_oldammo[id])
		//g_mode[id] = 2
		set_pdata_float(id, m_flNextAttack, 2.0, PLAYER_LINUX_XTRA_OFF)
		}
		}
		if(g_mode[id]==2)
		{
		set_task(1.5,"mode_new2",id)
		g_mode2[id] = 1
		UTIL_PlayWeaponAnimation(id, 6)
		//g_mode[id] = 0
		set_pdata_float(id, m_flNextAttack, 2.0, PLAYER_LINUX_XTRA_OFF)
		}

	}
		}
	}
	return PLUGIN_HANDLED
}
public mode_new(id)
{
g_mode[id] = 2
g_mode2[id] = 0
replace_weapon_models(id, CSW_AK47)
UTIL_PlayWeaponAnimation(id, 0)
new ak = find_ent_by_owner ( -1, "weapon_ak47", id )
set_pdata_int ( ak, 51, g_ammo[id], 4 )
}
public mode_new2(id)
{
g_mode[id] = 0
g_mode2[id] = 0
replace_weapon_models(id, CSW_AK47)
UTIL_PlayWeaponAnimation(id, 0)
new ak = find_ent_by_owner ( -1, "weapon_ak47", id )
set_pdata_int ( ak, 51, g_oldammo[id], 4 )
}
public client_connect(id)
{
	g_has_svdex[id] = false
}

public client_disconnect(id)
{
	g_has_svdex[id] = false
}

public zp_user_infected_post(id)
{
	if (zp_get_user_zombie(id))
	{
		g_has_svdex[id] = false
	}
}

public touch_m79nade ( ptr, ptd )
	// If ent is valid
	if (pev_valid(ptr))
	{	
		// Get classnames
		static classname[32], classnameptd[32]
		pev(ptr, pev_classname, classname, 31)
		pev(ptd, pev_classname, classnameptd, 31)
		
		// Our ent
		if(equal(classname, g_GrenadeEntity))
		{
			// Get it's origin
			new Float:originF[3]
			pev(ptr, pev_origin, originF)
			
			// Draw explosion
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(TE_EXPLOSION) // Temporary entity ID
			engfunc(EngFunc_WriteCoord, originF[0]) // engfunc because float
			engfunc(EngFunc_WriteCoord, originF[1])
			engfunc(EngFunc_WriteCoord, originF[2])
			write_short(sExplo) // Sprite index
			write_byte(50) // Scale
			write_byte(15) // Framerate
			write_byte(0) // Flags
			message_end()
			
			// Draw smoke
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(TE_SMOKE) // Temporary entity IF
			engfunc(EngFunc_WriteCoord, originF[0]) // Pos X
			engfunc(EngFunc_WriteCoord, originF[1]) // Pos Y
			engfunc(EngFunc_WriteCoord, originF[2]) // Pos Z
			write_short(sSmoke) // Sprite index
			write_byte(75) // Scale
			write_byte(15) // Framerate
			message_end()
			
			// Get owner
			new owner = pev(ptr, pev_owner)
			
			// Loop through all players
			for(new i = 1; i < 33; i++)
			{
				// Alive...
				if (is_user_alive(i) == 1)
				{
					// Start screen shake
					//message_begin(MSG_ONE, g_msgScreenShake, {0,0,0}, i)
					//write_short(1<<14) // Amount
					//write_short(1<<14) // Duration
					//write_short(1<<14) // Frequency
					//message_end()
					
					// A zombie/nemesis
					if (zp_get_user_zombie(i) || zp_get_user_nemesis(i))
					{
						// Get victims origin and distance
						new Float:VictimOrigin[3], Float:distance
						pev(i, pev_origin, VictimOrigin)
						
						// Get distance between victim and epicenter
						distance = get_distance_f(VictimOrigin, originF)
						
						if (distance <= get_pcvar_num(cvar_grenrad))
						{
							// Get victims health
							new health = get_user_health(i)
							
							// Still alive
							if (health - get_pcvar_num(cvar_grendmg) >= 1)
							{
								// Set health
								set_user_health(i, health - get_pcvar_num(cvar_grendmg))
							}
							else
							{
							kill(owner,i)
							}
						}
					}
				}
				// Destroy ent
				set_pev(ptr, pev_flags, FL_KILLME)
			}
			// We hit breakable
			if (equali(classnameptd, "func_breakable"))
			{
				// Destroy it
				force_use(ptr,ptd)
			}
		}
	}	

stock kill(k, v) {

	//set_user_frags(v, get_user_frags(v) + 1);
	
	//user_silentkill(v);

	new kteam = get_user_team(k);
	new vteam = get_user_team(v);
	
	new kfrags = get_user_frags(k) + 1;
	new kdeaths = get_user_deaths(k);
	
	new vfrags = get_user_frags(v);
	new vdeaths = get_user_deaths(v);
	
	message_begin(MSG_ALL, gmsgScoreInfo);
	write_byte(k);
	write_short(kfrags);
	write_short(kdeaths);
	write_short(0);
	write_short(kteam);
	message_end();
	
	message_begin(MSG_ALL, gmsgScoreInfo);
	write_byte(v);
	write_short(vfrags);
	write_short(vdeaths);
	write_short(0);
	write_short(vteam);
	message_end();
	
	message_begin(MSG_ALL, gmsgDeathMsg, {0,0,0}, 0);
	write_byte(k);
	write_byte(v);
	write_byte(0);
	write_string("SVDex");
	message_end();
	zp_set_user_ammo_packs(k, cs_get_user_money(k) + 1);
	set_user_frags(k, get_user_frags(k) + 1);
	set_msg_block(gmsgDeathMsg, BLOCK_ONCE)
	set_user_frags(v, get_user_frags(v) + 1);
	set_user_health(v,0)
}
public SendDeathMsg(attacker, victim)
{
	message_begin(MSG_BROADCAST, gmsgDeathMsg)
	write_byte(attacker) // killer
	write_byte(victim) // victim
	write_byte(0) // headshot flag
	write_string("grenade") // killer's weapon
	message_end()
}
public FixDeadAttrib(id)
{
	message_begin(MSG_BROADCAST, gmsgScoreAttrib)
	write_byte(id) // id
	write_byte(0) // attrib
	message_end()
}
public UpdateFrags(attacker, victim, frags, deaths, scoreboard)
{
	set_pev(attacker, pev_frags, float(pev(attacker, pev_frags) + frags))
	
	cs_set_user_deaths(victim, get_user_deaths(victim) + deaths)
	
	if (scoreboard)
	{	
		message_begin(MSG_BROADCAST, gmsgScoreInfo)
		write_byte(attacker) // id
		write_short(pev(attacker, pev_frags)) // frags
		write_short(get_user_deaths(attacker)) // deaths
		write_short(0) // class?
		write_short(get_user_team(attacker)) // team
		message_end()
		
		message_begin(MSG_BROADCAST, gmsgScoreInfo)
		write_byte(victim) // id
		write_short(pev(victim, pev_frags)) // frags
		write_short(get_user_deaths(victim)) // deaths
		write_short(0) // class?
		write_short(get_user_team(victim)) // team
		message_end()
	}
}
public fw_SetModel(entity, model[])
{
	if(!is_valid_ent(entity))
		return FMRES_IGNORED;
	
	static szClassName[33]
	entity_get_string(entity, EV_SZ_classname, szClassName, charsmax(szClassName))
		
	if(!equal(szClassName, "weaponbox"))
		return FMRES_IGNORED;
	
	static iOwner
	
	iOwner = entity_get_edict(entity, EV_ENT_owner)
	
	if(equal(model, "models/w_ak47.mdl"))
	{
		static iStoredSVDID
		
		iStoredSVDID = find_ent_by_owner(ENG_NULLENT, "weapon_ak47", entity)
	
		if(!is_valid_ent(iStoredSVDID))
			return FMRES_IGNORED;
	
		if(g_has_svdex[iOwner])
		{
			entity_set_int(iStoredSVDID, EV_INT_WEAPONKEY, svdex_WEAPONKEY)
			g_has_svdex[iOwner] = false
			
			entity_set_model(entity, svdex_W_MODEL)
			
			return FMRES_SUPERCEDE;
		}
	}
	
	
	return FMRES_IGNORED;
}
public give_svdex(id)
{
	if(!zp_get_user_survivor(id)) drop_weapons(id, 1);
	if(zp_get_user_survivor(id) && get_pcvar_num(cvar_survivor) == 1)
	{
	strip_user_weapons(id)
	give_item(id, "weapon_knife")
	}
	new iWep2 = give_item(id,"weapon_ak47")
	if( iWep2 > 0 )
	{
	cs_set_weapon_ammo(iWep2, get_pcvar_num(cvar_clip_svdex))
	cs_set_user_bpammo (id, CSW_AK47, get_pcvar_num(cvar_svdex_ammo))
	}
	g_ammo[id] = get_pcvar_num(cvar_gren)
	g_oldammo[id] = get_pcvar_num(cvar_clip_svdex)
	g_has_svdex[id] = true;
	replace_weapon_models(id, CSW_AK47)
}
public zp_extra_item_selected(id, itemid)
{
	if(itemid == g_itemid_svdex)
	{	
	give_svdex(id)
	}
	if(itemid == g_itemid2)
	{	
	if(!g_has_svdex[id])
	{
	print_col_chat( id,"^4[ZP]^1 You don't have a SVDex.") 
	zp_set_user_ammo_packs(id,cs_get_user_money(id) + 3)
	}else{
	if(g_ammo[id] + 1 > get_pcvar_num(cvar_gren))
	{
	print_col_chat( id,"^4[ZP]^1 You have maximum nades for SVDex.") 
	zp_set_user_ammo_packs(id,cs_get_user_money(id) + 3)
	}else{
	if(cs_get_user_money(id) < 3)
	{
	print_col_chat( id,"^4[ZP]^1 Don't have Ammo Packs.") 
	}else{
	g_ammo[id] = g_ammo[id] + 1
	print_col_chat( id,"^4[ZP]^1 You buy a nade for SVDex.") 
	if(get_user_weapon(id) == CSW_AK47 && g_mode[id] == 2 && g_has_svdex[id])
	{
	new ak = find_ent_by_owner ( -1, "weapon_ak47", id )
	set_pdata_int ( ak, 51, g_ammo[id], 4 )
	}
	}
	}
	}
	}
}
stock print_col_chat(const id, const input[], any:...)  
{  
new count = 1, players[32];  
static msg[191];  
vformat(msg, 190, input, 3);  
replace_all(msg, 190, "!g", "^4"); // Green Color  
replace_all(msg, 190, "!y", "^1"); // Default Color ( 湫)  
replace_all(msg, 190, "!t", "^3"); // Team Color  
if (id) players[0] = id; else get_players(players, count, "ch");  
{  
for ( new i = 0; i < count; i++ )  
{  
if ( is_user_connected(players[i]) )  
{  
message_begin(MSG_ONE_UNRELIABLE, SayText, _, players[i]);  
write_byte(players[i]);  
write_string(msg);  
message_end();  
}  
}  
}  
} 
public fw_svdex_AddToPlayer(svdex, id)
{
	if(!is_valid_ent(svdex) || !is_user_connected(id))
		return HAM_IGNORED;
	
	if(entity_get_int(svdex, EV_INT_WEAPONKEY) == svdex_WEAPONKEY)
	{
		g_has_svdex[id] = true
		
		entity_set_int(svdex, EV_INT_WEAPONKEY, 0)
		
		return HAM_HANDLED;
	}
	
	return HAM_IGNORED;
}

public fw_UseStationary_Post(entity, caller, activator, use_type)
{
	if (use_type == USE_STOPPED && is_user_connected(caller))
		replace_weapon_models(caller, get_user_weapon(caller))
}

public fw_Item_Deploy_Post(weapon_ent)
{
	static owner
	owner = fm_cs_get_weapon_ent_owner(weapon_ent)
	
	static weaponid
	weaponid = cs_get_weapon_id(weapon_ent)
	
	replace_weapon_models(owner, weaponid)
}

public CurrentWeapon(id)
{
	//replace_weapon_models(id, read_data(2))
}

replace_weapon_models(id, weaponid)
{
	if(id > 0 && id < 33 && is_user_alive(id))
	{
		if(weaponid == CSW_AK47)
		{
		if (zp_get_user_zombie(id) || zp_get_user_survivor(id) && get_pcvar_num(cvar_survivor) == 0)
		return;
			
		if(g_has_svdex[id] && g_mode2[id] == 0)
		{
		if(g_mode[id]==0)
		{
			if(g_anim[id]==0) set_task(0.1,"anim_new",id)
			set_pev(id, pev_viewmodel2, svdex_V_MODEL)
			set_pev(id, pev_weaponmodel2, svdex_P_MODEL)
		}else{
			if(g_anim[id]==0) set_task(0.1,"anim_new",id)
			set_pev(id, pev_viewmodel2, svdex_V_MODEL2)
			set_pev(id, pev_weaponmodel2, svdex_P_MODEL)
		}
		}
		}
		if(weaponid != CSW_AK47)
		{
		g_anim[id] = 0
		}
	}
}
public anim_new(id)
{
	g_anim[id] = 1
}
public fw_UpdateClientData_Post(Player, SendWeapons, CD_Handle)
{
	if(!is_user_alive(Player) || (get_user_weapon(Player) != CSW_AK47) || !g_has_svdex[Player])
	return FMRES_IGNORED
	
	set_cd(CD_Handle, CD_flNextAttack, halflife_time () + 0.001)
	return FMRES_HANDLED
}

public fw_svdex_PrimaryAttack(Weapon)
{
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	if(Player > 0 && Player < 33)
	{
			
	if (!g_has_svdex[Player])
		return;

	pev(Player,pev_punchangle,cl_pushangle[Player])

	if(g_mode[Player] == 0)	set_pdata_float(Player, m_flNextAttack, 0.5, PLAYER_LINUX_XTRA_OFF)
	if(g_mode[Player] == 0 && zp_get_user_survivor(Player) )
	{
	new ak = find_ent_by_owner ( -1, "weapon_ak47", Player )
	set_pdata_int ( ak, 51,  get_pcvar_num(cvar_clip_svdex), 4 )
	}
	if(g_mode[Player] == 2)	set_pdata_float(Player, m_flNextAttack, 3.0, PLAYER_LINUX_XTRA_OFF)
	
	g_clip_ammo[Player] = cs_get_weapon_ammo(Weapon)
	}
}

public fwPlaybackEvent(flags, invoker, eventid, Float:delay, Float:origin[3], Float:angles[3], Float:fparam1, Float:fparam2, iParam1, iParam2, bParam1, bParam2)
{
	if ((eventid != g_orig_event_svdex))
		return FMRES_IGNORED
	if (!(1 <= invoker <= g_MaxPlayers))
		return FMRES_IGNORED

	playback_event(flags | FEV_HOSTONLY, invoker, eventid, delay, origin, angles, fparam1, fparam2, iParam1, iParam2, bParam1, bParam2)
	return FMRES_SUPERCEDE
}

public fw_svdex_PrimaryAttack_Post(Weapon)
{
	new Player = get_pdata_cbase(Weapon, 41, 4)
	new szClip, szAmmo
	get_user_weapon(Player, szClip, szAmmo)
	if(Player > 0 && Player < 33)
	{
	if(!g_has_svdex[Player])
	{
	if(szClip > 0) emit_sound(Player, CHAN_WEAPON, "weapons/ak47-1.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
	}
	
	if(g_has_svdex[Player])
	{
		if(g_mode[Player] == 0)
		{
		new Float:push[3]
		pev(Player,pev_punchangle,push)
		xs_vec_sub(push,cl_pushangle[Player],push)
		
		xs_vec_mul_scalar(push,get_pcvar_float(cvar_recoil_svdex),push)
		xs_vec_add(push,cl_pushangle[Player],push)
		set_pev(Player,pev_punchangle,push)
		
		if (!g_clip_ammo[Player])
			return
		
		emit_sound(Player, CHAN_WEAPON, Fire_Sounds[0], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		//UTIL_PlayWeaponAnimation(Player, 4)
	
		make_blood_and_bulletholes(Player)
		}else{
		if(g_ammo[Player]  - 1 >= 0)
		{
		new Float:push[3]
		pev(Player,pev_punchangle,push)
		xs_vec_sub(push,cl_pushangle[Player],push)
		
		xs_vec_mul_scalar(push,get_pcvar_float(cvar_recoil_svdex),push)
		xs_vec_add(push,cl_pushangle[Player],push)
		set_pev(Player,pev_punchangle,push)
		
		emit_sound(Player, CHAN_WEAPON, Fire_Sounds[1], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		g_ammo[Player] = g_ammo[Player] - 1
		make_blood_and_bulletholes2(Player)	
		}

		}
		}
	}
}

public fw_TakeDamage(victim, inflictor, attacker, Float:damage)
{
	if (victim != attacker && is_user_connected(attacker))
	{
		if(get_user_weapon(attacker) == CSW_AK47)
		{
			if(g_has_svdex[attacker] && g_mode[attacker] == 0)
			{
			SetHamParamFloat(4, get_pcvar_float(cvar_dmg_svdex))
			new Float:vec[3];
			new Float:oldvelo[3];
			get_user_velocity(victim, oldvelo);
			create_velocity_vector(victim , attacker , vec);
			vec[0] += oldvelo[0];
			vec[1] += oldvelo[1];
			set_user_velocity(victim , vec);
			}
			if(g_has_svdex[attacker] && g_mode[attacker] == 2)
			{
			SetHamParamFloat(4, 0.0)			
			}

		}
	}
}

public message_DeathMsg(msg_id, msg_dest, id)
{
	static szTruncatedWeapon[33], iAttacker, iVictim
	
	get_msg_arg_string(4, szTruncatedWeapon, charsmax(szTruncatedWeapon))
	
	iAttacker = get_msg_arg_int(1)
	iVictim = get_msg_arg_int(2)
	
	if(!is_user_connected(iAttacker) || iAttacker == iVictim)
		return PLUGIN_CONTINUE
	
	if(equal(szTruncatedWeapon, "ak47") && get_user_weapon(iAttacker) == CSW_AK47)
	{
		if(g_has_svdex[iAttacker])
			set_msg_arg_string(4, "ak47")
	}
		
	return PLUGIN_CONTINUE
}

stock fm_cs_get_current_weapon_ent(id)
{
	return get_pdata_cbase(id, OFFSET_ACTIVE_ITEM, OFFSET_LINUX);
}

stock fm_cs_get_weapon_ent_owner(ent)
{
	return get_pdata_cbase(ent, OFFSET_WEAPONOWNER, OFFSET_LINUX_WEAPONS);
}

stock UTIL_PlayWeaponAnimation(const Player, const Sequence)
{
	set_pev(Player, pev_weaponanim, Sequence)
	
	message_begin(MSG_ONE_UNRELIABLE, SVC_WEAPONANIM, .player = Player)
	write_byte(Sequence)
	write_byte(pev(Player, pev_body))
	message_end()
}
stock create_velocity_vector(victim,attacker,Float:velocity[3])
{
    if(victim > 0 && victim < 33)
    {
    if(!zp_get_user_zombie(victim) || !is_user_alive(attacker))
        return 0;

    new Float:vicorigin[3];
    new Float:attorigin[3];
    entity_get_vector(victim   , EV_VEC_origin , vicorigin);
    entity_get_vector(attacker , EV_VEC_origin , attorigin);

    new Float:origin2[3]
    origin2[0] = vicorigin[0] - attorigin[0];
    origin2[1] = vicorigin[1] - attorigin[1];

    new Float:largestnum = 0.0;

    if(floatabs(origin2[0])>largestnum) largestnum = floatabs(origin2[0]);
    if(floatabs(origin2[1])>largestnum) largestnum = floatabs(origin2[1]);

    origin2[0] /= largestnum;
    origin2[1] /= largestnum;
    new a
    if(!zp_get_user_survivor(attacker))
    {
    a = get_pcvar_num(cvar_knockback)
    }else{
    a = get_pcvar_num(cvar_knockbacksurv)
    }
    
    velocity[0] = ( origin2[0] * (100 *a) ) / get_entity_distance(victim , attacker);
    velocity[1] = ( origin2[1] * (100 *a) ) / get_entity_distance(victim , attacker);
    if(velocity[0] <= 20.0 || velocity[1] <= 20.0)
        velocity[2] = random_float(200.0 , 275.0);
    }

    return 1;
}

stock make_blood_and_bulletholes2(id)
{	// Get origin. angle and velocity
	new Float:fOrigin[3], Float:fAngle[3], Float:fVelocity[3]
	pev(id, pev_origin, fOrigin)
	pev(id, pev_v_angle, fAngle)
	
	UTIL_PlayWeaponAnimation(id, 4)

	// Create ent
	new grenade = create_entity("info_target")
	
	// Not grenade
	if (!grenade) return PLUGIN_HANDLED
	
	// Classname
	entity_set_string(grenade, EV_SZ_classname, g_GrenadeEntity)
	
	// Model
	entity_set_model(grenade, GRENADE_MODEL)
	
	// Origin
	entity_set_origin(grenade, fOrigin)
	
	// Angles
	entity_set_vector(grenade, EV_VEC_angles, fAngle)
	
	// Size
	new Float:MinBox[3] = {-1.0, -1.0, -1.0}
	new Float:MaxBox[3] = {1.0, 1.0, 1.0}
	entity_set_vector(grenade, EV_VEC_mins, MinBox)
	entity_set_vector(grenade, EV_VEC_maxs, MaxBox)
	
	// Interaction
	entity_set_int(grenade, EV_INT_solid, SOLID_SLIDEBOX)
	
	// Movetype
	entity_set_int(grenade, EV_INT_movetype, MOVETYPE_TOSS)
	
	// Owner
	entity_set_edict(grenade, EV_ENT_owner, id)
	
	// Effects
	entity_set_int(grenade, EV_INT_effects, EF_BRIGHTLIGHT)
	
	// Velocity
	VelocityByAim(id, 1500, fVelocity)
	entity_set_vector(grenade, EV_VEC_velocity, fVelocity)
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_BEAMFOLLOW) // Temporary entity ID
	write_short(grenade) // Entity
	write_short(sTrail) // Sprite index
	write_byte(10) // Life
	write_byte(3) // Line width
	write_byte(255) // Red
	write_byte(255) // Green
	write_byte(255) // Blue
	write_byte(255) // Alpha
	message_end() 
	
	if(zp_get_user_survivor(id) && get_pcvar_num(cvar_unlim)) g_ammo[id] = get_pcvar_num(cvar_gren)
	new ak = find_ent_by_owner ( -1, "weapon_ak47", id )
	set_pdata_int ( ak, 51, g_ammo[id], 4 )

	if(g_ammo[id] == 0)
	{
	UTIL_PlayWeaponAnimation(id, 6)
	//g_mode[id] = 0
	set_task(1.0,"new_anim3",id)
	if(zp_get_user_survivor(id))
	{
	new ak = find_ent_by_owner ( -1, "weapon_ak47", id )
	set_pdata_int ( ak, 51, get_pcvar_num(cvar_clip_svdex), 4 )
	}else{
	new ak = find_ent_by_owner ( -1, "weapon_ak47", id )
	set_pdata_int ( ak, 51, g_oldammo[id], 4 )
	}
	set_pdata_float(id, m_flNextAttack, 2.0, PLAYER_LINUX_XTRA_OFF)
	}

	return PLUGIN_CONTINUE
}
public new_anim3(id)
{
	g_mode[id] = 0
	replace_weapon_models(id, CSW_AK47)
	UTIL_PlayWeaponAnimation(id, 0)
}
stock make_blood_and_bulletholes(id)
{
	//set_pdata_int ( id, 51, 60, 4)
	//set_pdata_int(CSW_AK47, m_iClip, 1, 4)
	new aimOrigin[3], target, body
	get_user_origin(id, aimOrigin, 3)
	get_user_aiming(id, target, body)
	
	UTIL_PlayWeaponAnimation(id, 4)

	if(zp_get_user_survivor(id))
	{
	new ak = find_ent_by_owner ( -1, "weapon_ak47", id )
	set_pdata_int ( ak, 51, get_pcvar_num(cvar_clip_svdex), 4 )
	}

	if(target > 0 && target <= g_MaxPlayers && zp_get_user_zombie(target))
	{
		new Float:fStart[3], Float:fEnd[3], Float:fRes[3], Float:fVel[3]
		pev(id, pev_origin, fStart)
		
		velocity_by_aim(id, 64, fVel)
		
		fStart[0] = float(aimOrigin[0])
		fStart[1] = float(aimOrigin[1])
		fStart[2] = float(aimOrigin[2])
		fEnd[0] = fStart[0]+fVel[0]
		fEnd[1] = fStart[1]+fVel[1]
		fEnd[2] = fStart[2]+fVel[2]
		
		new res
		engfunc(EngFunc_TraceLine, fStart, fEnd, 0, target, res)
		get_tr2(res, TR_vecEndPos, fRes)
		
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY) 
		write_byte(TE_BLOODSPRITE)
		write_coord(floatround(fStart[0])) 
		write_coord(floatround(fStart[1])) 
		write_coord(floatround(fStart[2])) 
		write_short( m_iBlood [ 1 ])
		write_short( m_iBlood [ 0 ] )
		write_byte(70)
		write_byte(random_num(1,2))
		message_end()
		
		
	} 
	else if(!is_user_connected(target))
	{
		if(target)
		{
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(TE_DECAL)
			write_coord(aimOrigin[0])
			write_coord(aimOrigin[1])
			write_coord(aimOrigin[2])
			write_byte(GUNSHOT_DECALS[random_num ( 0, sizeof GUNSHOT_DECALS -1 ) ] )
			write_short(target)
			message_end()
		} 
		else 
		{
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(TE_WORLDDECAL)
			write_coord(aimOrigin[0])
			write_coord(aimOrigin[1])
			write_coord(aimOrigin[2])
			write_byte(GUNSHOT_DECALS[random_num ( 0, sizeof GUNSHOT_DECALS -1 ) ] )
			message_end()
		}
		
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_GUNSHOTDECAL)
		write_coord(aimOrigin[0])
		write_coord(aimOrigin[1])
		write_coord(aimOrigin[2])
		write_short(id)
		write_byte(GUNSHOT_DECALS[random_num ( 0, sizeof GUNSHOT_DECALS -1 ) ] )
		message_end()
	}
}

public svdex__ItemPostFrame(weapon_entity) {
	new id = pev(weapon_entity, pev_owner)
	if (!is_user_connected(id))
		return HAM_IGNORED;

	if (!g_has_svdex[id])
		return HAM_IGNORED;

	new Float:flNextAttack = get_pdata_float(id, m_flNextAttack, PLAYER_LINUX_XTRA_OFF)

	new iBpAmmo = cs_get_user_bpammo(id, CSW_AK47);
	new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)

	new fInReload = get_pdata_int(weapon_entity, m_fInReload, WEAP_LINUX_XTRA_OFF) 

	if( fInReload && flNextAttack <= 0.0 )
	{
		new j = min(get_pcvar_num(cvar_clip_svdex) - iClip, iBpAmmo)
	
		set_pdata_int(weapon_entity, m_iClip, iClip + j, WEAP_LINUX_XTRA_OFF)
		cs_set_user_bpammo(id, CSW_AK47, iBpAmmo-j);
		
		set_pdata_int(weapon_entity, m_fInReload, 0, WEAP_LINUX_XTRA_OFF)
		g_reload[id] = 0
		fInReload = 0
	}

	return HAM_IGNORED;
}

public svdex__Reload(weapon_entity) {
	new id = pev(weapon_entity, pev_owner)
	if (!is_user_connected(id))
		return HAM_IGNORED;

	if (!g_has_svdex[id])
		return HAM_IGNORED;

	g_svdex_TmpClip[id] = -1;

	new iBpAmmo = cs_get_user_bpammo(id, CSW_AK47);
	new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)

	if (iBpAmmo <= 0)
		return HAM_SUPERCEDE;

	if (iClip >= get_pcvar_num(cvar_clip_svdex))
		return HAM_SUPERCEDE;


	g_svdex_TmpClip[id] = iClip;

	g_reload[id] = 1

	return HAM_IGNORED;
}
public svdex__Reload_Post(weapon_entity) {
	new id = pev(weapon_entity, pev_owner)
	if (!is_user_connected(id))
		return HAM_IGNORED;


	if(g_mode[id] == 1)
	{
	if (!g_has_svdex[id])
		return HAM_IGNORED;

	if (g_svdex_TmpClip[id] == -1)
		return HAM_IGNORED;

	set_pdata_int(weapon_entity, m_iClip, g_svdex_TmpClip[id], WEAP_LINUX_XTRA_OFF)

	set_pdata_float(weapon_entity, m_flTimeWeaponIdle, svdex_RELOAD_TIME, WEAP_LINUX_XTRA_OFF)

	set_pdata_float(id, m_flNextAttack, svdex_RELOAD_TIME, PLAYER_LINUX_XTRA_OFF)

	set_pdata_int(weapon_entity, m_fInReload, 1, WEAP_LINUX_XTRA_OFF)

	// relaod animation
	if(g_mode[id] == 0)
	{
	//UTIL_PlayWeaponAnimation(id, 1)
	}
	}

	return HAM_IGNORED;
}

stock drop_weapons(id, dropwhat)
{
     static weapons[32], num, i, weaponid
     num = 0
     get_user_weapons(id, weapons, num)
     
     for (i = 0; i < num; i++)
     {
          weaponid = weapons[i]
          
          if (dropwhat == 1 && ((1<<weaponid) & PRIMARY_WEAPONS_BIT_SUM))
          {
               static wname[32]
               get_weaponname(weaponid, wname, sizeof wname - 1)
               engclient_cmd(id, "drop", wname)
          }
     }
}
